#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <arpa/inet.h>

#ifdef PAL60
#define PSO_PORT 9200
#elif PAL50
#define PSO_PORT 9201
#elif NTSCUC
#define PSO_PORT 9100
#else
#define PSO_PORT 9200
#endif



#define CONNECT_STR_LEN 0x4C
const char connect_str[] = {0x17,0x00,0x4C,0x00,0x44,0x72,0x65,0x61,0x6D,0x43,0x61,0x73,0x74,0x20,0x50,
			    0x6F,0x72,0x74,0x20,0x4D,0x61,0x70,0x2E,0x20,0x43,0x6F,0x70,0x79,0x72,0x69,
			    0x67,0x68,0x74,0x20,0x53,0x45,0x47,0x41,0x20,0x45,0x6E,0x74,0x65,0x72,0x70,
			    0x72,0x69,0x73,0x65,0x73,0x2E,0x20,0x31,0x39,0x39,0x39,0x00,0x00,0x00,0x00,
			    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x33,0x22,0x11,0x88,0x77,0x66,0x55};

struct crypt_table

{
  unsigned int table[0x400];
  unsigned int *pCurr, *pEnd;
} encode_table, decode_table;

#define TABLE_END 0x20A

void print_table(struct crypt_table *tbl)

{
  int i;
  for(i = 0; i < TABLE_END; i++)
    {
      printf("%x - %08X\n", (unsigned int) i << 2, tbl->table[i]);
    }
  printf("pCurr - 0x%p\n", tbl->pCurr);
  printf("pEnd  - 0x%p\n", tbl->pEnd);
}

void fixup_block(struct crypt_table *tbl)

{
  unsigned int *pLoc = tbl->table + 1;

  tbl->pCurr = pLoc;
  while(pLoc != (tbl->pEnd - 0x1E9)) /* Copy top end and xor */
    {
      *pLoc ^= *(pLoc + 0x1E9);
      pLoc++;
    }

  if(pLoc < tbl->pEnd)
    {
      unsigned int *pLoop;
      pLoop = tbl->table + 1;
      while(pLoc < tbl->pEnd)
	{
	  *pLoc ^= *pLoop;
	  pLoop++;
	  pLoc++;
	}
    }
}

void build_codetbl(int seed, struct crypt_table *tbl)

{
  int i, j;
  unsigned int curr_val = seed;
  unsigned int *pFixup;

  tbl->pCurr = tbl->table + 1;
  tbl->pEnd = tbl->table + TABLE_END;

  *tbl->pCurr = 0;

  for(i = 0; i < 0x11; i++)
    {
      for(j = 0x20; j > 0; j--)
	{
	  curr_val = (unsigned int) (((int) curr_val * (int) 0x5D588B65) + 1);
	  *tbl->pCurr |= ((curr_val & 0x80000000) >> (j-1));
	}
      tbl->pCurr++;
    }

  *(tbl->pCurr - 1) = (tbl->table[1] >> 9) ^ (*(tbl->pCurr - 1) << 0x17) ^ tbl->table[0x10];
  pFixup = &tbl->table[1];
  while(tbl->pCurr < tbl->pEnd)
    {
      *tbl->pCurr = (*(pFixup + 1) >> 9) ^ (*pFixup << 0x17) ^ *(tbl->pCurr - 1);
      pFixup++;
      tbl->pCurr++;
    }
  
  for(i = 0; i < 3; i++)
    {
      //print_table(tbl);
      fixup_block(tbl);
    }
  
  tbl->pCurr = tbl->table + TABLE_END - 1;
}

void code_block(unsigned int *buf, int len, struct crypt_table *tbl)

{
  unsigned int *pStart, *pEnd;

  len = (len + 3) >> 2;
  if(len > 0) /* If not 1 complete long */
    {
      pStart = buf;
      pEnd = buf + len;
      while(pStart < pEnd)
	{
	  tbl->pCurr++;
	  if(tbl->pCurr == tbl->pEnd)
	    {
	      fixup_block(tbl); 
	    }
	  *pStart ^= *tbl->pCurr;
	  pStart++;
	}
    }
}

char buf[0x400];
int send_count;
unsigned int reply_data = 0x0004009A;
int rtn_wait;

int make_socket (ushort port)
{
  int sock;
  struct sockaddr_in name;
  
  /* Create the socket. */
  sock = socket (PF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    {
      perror ("socket");
      exit (EXIT_FAILURE);
    }
  
  /* Give the socket a name. */
  name.sin_family = AF_INET;
  name.sin_port = htons (port);
  name.sin_addr.s_addr = htonl (INADDR_ANY);
  if (bind (sock, (struct sockaddr *) &name, sizeof (name)) < 0)
    {
      perror ("bind");
      exit (EXIT_FAILURE);
    }
  
  return sock;
}

int data_write(int csock)

{
  if(send_count == 0)
    {
      printf("Write data response\n");
      code_block(&reply_data, 4, &encode_table);
      write(csock, &reply_data, 4);
    }
  send_count++;

  return 0;
}

int data_read(int csock)

{
  int rlen;
/*   int i; */

  rlen = read(csock, buf, 0x3E8);
  if(rlen < 0)
    {
      perror("read");
      exit(EXIT_FAILURE);
    }
  
  if(rlen == 0)
    {
      return -1;
    }

/*   printf("Original block len %d\n", rlen); */
/*   for(i = 0; i < rlen; i++) */
/*     { */
/*       printf("%02X", (unsigned char) buf[i]); */
/*     } */
/*   printf("\n"); */
  code_block((unsigned int *) buf, rlen, &decode_table);
/*   printf("Decrypted block len %d\n", rlen); */
/*   for(i = 0; i < rlen; i++) */
/*     { */
/*       printf("%02X", (unsigned char) buf[i]); */
/*     } */
/*   printf("\n"); */
  data_write(csock);

  if(rtn_wait)
    {
      printf("Return code recieve %08X\n", *(unsigned int *) &buf[4]);
      rtn_wait = 0;
    }

  return 0;
}

void run_program(const char *filename, int sock)
     
{
  FILE *fp;
  unsigned int *sendbuf;

  fp = fopen(filename, "rb");
  if(fp != NULL)
    {
      int flen;
      int flen_words;

      fseek(fp, 0, SEEK_END);
      flen = ftell(fp);
      fseek(fp, 0, SEEK_SET);
      flen_words = (flen + 3) >> 2;
      sendbuf = (unsigned int *) malloc(flen_words << 2);
      if(sendbuf == NULL)
	{
	  printf("Couldnt allocate memory for file\n");
	  fclose(fp);
	  return;
	}
      memset(sendbuf, 0, flen_words << 2);
      flen = fread(sendbuf, 1, flen, fp);
      printf("Send file %s - %d bytes\n", filename, flen);
      code_block(sendbuf, flen, &encode_table);
      write(sock, sendbuf, flen);
      fclose(fp);
      free(sendbuf);
      rtn_wait = 1;
    }
  else
    {
      printf("ERROR : Could not open %s\n", filename);
    }
}

void start_server()

{
  /* Bind socket to 9200/1 and start listening for connections */
  int ssock; /* Server socket */
  int csock; /* Client socket */
  fd_set active_fd_set, read_fd_set, write_fd_set;
  int i;
  struct sockaddr_in clientname;
  size_t size;
  int conn_count = 0;

/*   memset(&encode_table, 0, sizeof(struct crypt_table)); */
/*   memset(&decode_table, 0, sizeof(struct crypt_table)); */
/*   build_codetbl(0x11223344, &encode_table); */
/*   build_codetbl(0x55667788, &decode_table); */

  csock = -1;
  ssock = make_socket(PSO_PORT);
  if(listen(ssock, 1) < 0)
    {
      perror("listen");
      exit(EXIT_FAILURE);
    }

  FD_ZERO(&active_fd_set);
  FD_SET(ssock, &active_fd_set);
  FD_SET(STDIN_FILENO, &active_fd_set);
  while(1)
    {
      read_fd_set = active_fd_set;
      write_fd_set = active_fd_set;
      if(select(FD_SETSIZE, &read_fd_set, &write_fd_set, NULL, NULL) < 0)
	{
	  perror("select");
	  exit(EXIT_FAILURE);
	}

      for(i = 0; i < FD_SETSIZE; ++i)
	{
	  if(FD_ISSET(i, &write_fd_set))
	    {
	      if(i == csock)
		{
		  data_write(i);
		}
	    }

	  if(FD_ISSET(i, &read_fd_set))
	    {
	      if(i == ssock)
		{
		  /* New connection */
		  if(conn_count == 0)
		    {
		      size = sizeof(clientname);
		      csock = accept(ssock, (struct sockaddr *) &clientname, &size);
		      if(csock < 0)
			{
			  perror("accept");
			  exit(EXIT_FAILURE);
			}
		      fprintf(stderr, "Connection from %s port %d\n", inet_ntoa(clientname.sin_addr), 
			      ntohs(clientname.sin_port));
		      FD_SET(csock, &active_fd_set);
		      send_count = 0;
		      reply_data = 0x0004009A;
		      rtn_wait = 0; /* not waiting on a return code */
		      write(csock, connect_str, CONNECT_STR_LEN);
		      conn_count = 1;
		      memset(&encode_table, 0, sizeof(struct crypt_table));
		      memset(&decode_table, 0, sizeof(struct crypt_table));
		      build_codetbl(0x11223344, &encode_table);
		      build_codetbl(0x55667788, &decode_table);
		    }
		}
	      else if(i == csock)
		{
		  if(data_read(i) < 0)
		    {
		      close(i);
		      FD_CLR(i, &active_fd_set);
		      conn_count = 0;
		      csock = -1;
		    }
		}
	      else if(i == STDIN_FILENO)
		{
		  int rlen;

		  rlen = read(STDIN_FILENO, buf, 1023);
		  rlen--;
		  while((rlen > 0) && (buf[rlen] < 32))
		    {
		      buf[rlen--] = 0;
		    }
		  if(csock != -1)
		    {
		      run_program(buf, csock);
		    }
		}
	    }
	}
    }
}

int main()

{     
  /* Configure a listening socket */
  printf("Staring PSO Server on port %d\n", PSO_PORT);
  start_server();
  //print_table(&encode_table);
  //print_table(&decode_table);

  return 0;
}
